#include "TextureSet.h"

namespace apig {

int TextureSet::add(Texture* texture) {
    list.append(texture);
    return list.size() - 1;
    }

void TextureSet::load() const {
    foreach (Texture *tex, list) tex->load();
    }

void TextureSet::activate() const {
    int n = 0;
    foreach (Texture *tex, list) tex->activate(n++);    // associe la texture <tex>  l'unite de texture <n>
    }

void TextureSet::deactivate() const {
    int n = 0;
    foreach (Texture *tex, list) tex->deactivate(n++);  // desactive l'unite de texture <n>
    }

void TextureSet::clear() {
    // les textures ne sont pas detruites :
    list.clear();
    }

}

